-----------------
-- Queue bench --
-----------------

benchPushPop push pop =
  Criterion.bench (num02 push ++ "_" ++ num02 pop) $
    Criterion.whnf (work) (push, pop)
  where work :: (Int, Int) -> Bool
        work (push, pop) = do_push qEmpty push
          where do_push q i | q `seq` i `seq` False = undefined
                do_push q 0 = do_pop q pop
                do_push q i = do_push (() `qPush` q) (i-1)
                do_pop q i | q `seq` i `seq` False = undefined
                do_pop q 0 = qNull q
                do_pop q i = do_pop (qPop q) (i-1)

benchPushPops lens = Criterion.bgroup "queue" [benchPushPop push pop | (push, pop) <- lens]

-------------
-- All benchs
-------------
num02 n | n < 10 = '0' : (show n)
        | otherwise = (show n)

main = Progression.defaultMain $ Criterion.bgroup ""
  [ benchPushPops [(push, pop) | push <- [8, 12, 16, 20], pop <- [1, push`div`2, push]]
  ]
