#!/bin/bash

set -e

function init() {
  [ -d ../packages.conf ] && rm -rf ../packages.conf
  ghc-pkg init ../packages.conf
}

function build() {
  cd $1
  cabal clean
  cabal configure --package-db=../../packages.conf
  cabal build --ghc-pkg-option=--package-conf=../../packages.conf/
  cabal register --inplace
  cd ..
}

init

build binary-0.5.0.2 &
build COrdering-2.3 &
build deepseq-1.1.0.0 &
build erf-1.0.0.0 &
build hashmap-1.0.0.2 &
build hashmap-noc-1.0.0 &
build hashmap-spec-1.0.0.2 &
build mtl-1.1.0.2 &
build my-containers &
build my-ghc-containers &
build primitive-0.3 &
build QuickCheck-1.2.0.0 &
build random-access-list-0.2 &
build TreeStructures-0.0.2 &
build utf8-string-0.3.6 &
wait

build AvlTree-4.2 &
build bytestring-trie-0.1.4 &
build dlist-0.5 &
build EdisonAPI-1.2.1 &
build haskeline-0.6.2.2 &
build parallel-2.2.0.1 &
build parsec-3.1.0 &
build regex-base-0.93.1 &
build TernaryTrees-0.1.3.4 &
build vector-0.6.0.1 &
wait

build EdisonCore-1.2.1.3 &
build list-tries-0.2 &
build mwc-random-0.5.0.0 &
build regex-posix-0.94.1 &
build vector-algorithms-0.3.2 &
wait

build statistics-0.5.1.0 &
build txt-sushi-0.5.1 &
wait

build criterion-0.5.0.0
build progression-0.3
